#define __STDC_FORMAT_MACROS
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <sys/mman.h>
#include <fcntl.h>

int main(int arc, char **argv) {
    struct stat st1, st2;
    if (stat(argv[1], &st1) != 0) {
        perror("stat");
        return 1;
    }
    if (stat(argv[2], &st2) != 0) {
        perror("stat");
        return 1;
    }
    if (st1.st_size != st2.st_size) {
        fprintf(stderr, "Error: files must be the same size.\n");
        return 2;
    }
    uint8_t *file1, *file2;
    int fd1, fd2;
    fd1 = open(argv[1], O_RDONLY);
    fd2 = open(argv[2], O_RDONLY);
    file1 = (uint8_t *) mmap(NULL, st1.st_size, PROT_READ, MAP_PRIVATE, fd1, 0);
    if (file1 == NULL) {
        perror("mmap");
        return 1;
    }
    file2 = (uint8_t *) mmap(NULL, st2.st_size, PROT_READ, MAP_PRIVATE, fd2, 0);
    if (file2 == NULL) {
        perror("mmap");
        return 1;
    }

    // Output the "reference" filename so we know what to base from
    printf("%s\n", argv[1]);

    off_t diffs = 0;
    for (off_t i = 0; i < st1.st_size; i++) {
        if (file1[i] != file2[i]) {
            printf("%" PRIx64 " %02x\n", i, file2[i]);
            diffs++;
        }
        if (diffs > 256) return 2;
    }

    return 0;
}
