#!/bin/bash

success=0
uuid=${1}
for ref in logs/rr/references/*; do
    ~/bin/bdiff ${ref} logs/rr/${uuid}-rr-snp > logs/rr/${uuid}.patch
    ret=$?
    if [ $ret -eq 0 ]; then
        tar cJvf logs/rr/${uuid}.txz logs/rr/${uuid}.patch logs/rr/${uuid}-rr-nondet.log
        success=1
        break
    elif [ $ret -eq 1 ]; then
        :
    elif [ $ret -eq 2 ]; then
        :
    else
        print "Got bad return value $ret ; wtf?"
        exit 1
    fi
done

if [ $success -eq 0 ]; then
    # None of our references matched; make a new one
    echo "Adding snapshot ${uuid}-rr-snp as new reference"
    cp logs/rr/${uuid}-rr-snp logs/rr/references/
    # Add this as a patch
    ~/bin/bdiff logs/rr/${uuid}-rr-snp logs/rr/${uuid}-rr-snp > logs/rr/${uuid}.patch
    tar cJvf logs/rr/${uuid}.txz logs/rr/${uuid}.patch logs/rr/${uuid}-rr-nondet.log
fi

rm -f logs/rr/${uuid}-rr-snp logs/rr/${uuid}.patch logs/rr/${uuid}-rr-nondet.log

